eval {
	use Fcntl;
	use AnyDBM_File;
};

&error("You don't have the required modules installed: $@") if ($@);

tie(%users,'AnyDBM_File',"$tokens{data_dir}/dbm/users",O_CREAT | O_RDWR,0666) || &error("Can't open user database: $!");

my %columns = ();

sub user_create {
	my ($user,%user) = @_;

	$user{status} ||= 0;

	my @user = ();
	foreach (keys(%user)) { push(@user,"$_=$user{$_}"); }
	$users{$user} = join("\t",@user);
}

sub user_display {
	my ($user) = @_;

	my %user = ();

	foreach (split(/\t/,$users{$user})) {
		my @line = split(/=/,$_,2);
		$user{$line[0]} = $line[1];
	}

	return %user;
}

sub user_display_one {
	my ($user,$column) = @_;

	if ($columns{"$user,$column"}) {
		return $columns{"$user,$column"};
	} else {
		return $columns{"$user,$column"} = ($users{$user} =~ /(^|\t)$column\=(.*?)(\t|$)/si)[1];
	}
}

sub user_modify {
	my ($user,%data) = @_;

	my %user = &user_display($user);

	foreach (keys(%data)) { $user{$_}=$data{$_}; }

	my @user = ();
	foreach (keys(%user)) { push(@user,"$_=$user{$_}"); }
	$users{$user} = join("\t",@user);
}

sub user_remove {
	my ($user) = @_;

	my %user = &user_display($user);

	delete $users{$user};

	&dir_remove("$tokens{root_dir}/$user");
}

sub user_exist {
	my ($user) = @_;

	return (1) if ($users{$user});
	return ();
}

1;